/**********************************************************
 * File: zrecv.c
 * Created at Fri Jul 16 18:06:30 1999 by pk // aaz@ruxy.org.ru
 * receive zmodem, based on code by Chuck Forsberg
 * $Id: zrecv.c,v 1.6 2000/11/10 12:37:22 lev Exp $
 **********************************************************/
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <utime.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include "mailer.h"
#include "defs.h"
#include "zmodem.h"
#include "qipc.h"
#include "globals.h"

#define N_ZFINS 1

int tryzhdrtype=ZRINIT;	/* Header type to send corresponding to Last rx close */
static long total_length = 0;           /*          its length */
static char will_skip = 0;              /* skipping trigger.
                                           if set - than we want to skip current
                                           file. */


int procheader(char *name, char *path)
{
	char *p;
	int a,b,c,d,e,f;
#ifdef Z_DEBUG
	write_log("prochdr");
#endif	
	sline("ZRecv %s", name);
	p=name+1+strlen(name);
	if(*p) sscanf(p, "%d %o %d %d %d %d", &a, &b, &c, &d, &e, &f);
        total_length = a;
        will_skip = 0;
	switch(rxopen(name, b, a, &rxfd)) {
	case FOP_SKIP:
		return ZSKIP;
	case FOP_SUSPEND:
		return ERROR;
	case FOP_CONT:
		rxpos=recvf.soff;
		fseek(rxfd, rxpos, SEEK_SET);
		break;
	case FOP_OK:
		rxpos=0;
	}
	return OK;
}

/*
 * Ack a ZFIN packet, let byegones be byegones
 */
void ackbibi()
{
	int n;

#ifdef Z_DEBUG	
	write_log("ackbibi");
#endif
	stohdr(0L);
	for (n=3; --n>=0; ) {
		PURGE();
		zshhdr(4,ZFIN, Txhdr);
		switch (GETCHAR(10)) {
		case ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
			zgethdr(Rxhdr);
			break;
		case 'O':
		ZPAD:
	